# discover_snoop

DiscoverSnoop - JavaScript client for discover_snoop
API for DiscoverSnoop Service
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.9.250210
- Package version: 0.9.250210
- Build package: io.swagger.codegen.v3.generators.javascript.JavaScriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install discover_snoop --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var DiscoverSnoop = require('discover_snoop');
var defaultClient = DiscoverSnoop.ApiClient.instance;


var api = new DiscoverSnoop.AlertsApi()
var id = "id_example"; // {String} ID of the alert to edit ; if adding a new one leave blank
var alertname = "alertname_example"; // {String} Name of the alert
var activated = true; // {Boolean} Should the alert be activated or not
var type = 56; // {Number} Alert type (1= New content for website, 2=New performing contents), 3=New contents in category
var channel = 56; // {Number} 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON
var recipient = "recipient_example"; // {String} Email address of recipient or webhook for Slack/Gchat or JSON endpoint
var opts = { 
  'param1': "param1_example", // {String} Parameter 1 (meaning changes with alert type)
  'param2': "param2_example", // {String} Parameter 2 (meaning changes with alert type)
  'param3': "param3_example", // {String} Parameter 3 (meaning changes with alert type)
  'param4': "param4_example", // {String} Parameter 4 (meaning changes with alert type)
  'param5': "param5_example", // {String} Parameter 5 (meaning changes with alert type)
  'param6': "param6_example" // {String} Parameter 6 (meaning changes with alert type)
};
var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.alertsChangeGet(id, alertname, activated, type, channel, recipient, opts, callback);
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DiscoverSnoop.AlertsApi* | [**alertsChangeGet**](docs/AlertsApi.md#alertsChangeGet) | **GET** /alerts_change | Edit or insert new alert
*DiscoverSnoop.AlertsApi* | [**alertsDeleteGet**](docs/AlertsApi.md#alertsDeleteGet) | **GET** /alerts_delete | Permanently delete the alert
*DiscoverSnoop.AlertsApi* | [**alertsGet**](docs/AlertsApi.md#alertsGet) | **GET** /alerts | Get alerts for user account
*DiscoverSnoop.FavsApi* | [**favsAddGet**](docs/FavsApi.md#favsAddGet) | **GET** /favs_add | Create a new fav
*DiscoverSnoop.FavsApi* | [**favsDeleteGet**](docs/FavsApi.md#favsDeleteGet) | **GET** /favs_delete | Permanently delete the fav
*DiscoverSnoop.FavsApi* | [**favsGet**](docs/FavsApi.md#favsGet) | **GET** /favs | Get favorites
*DiscoverSnoop.FavsApi* | [**favsUpdateGet**](docs/FavsApi.md#favsUpdateGet) | **GET** /favs_update | Update the fav
*DiscoverSnoop.HistoricalApi* | [**categoriesGet**](docs/HistoricalApi.md#categoriesGet) | **GET** /categories | Get historical stats for categories
*DiscoverSnoop.HistoricalApi* | [**categoryGet**](docs/HistoricalApi.md#categoryGet) | **GET** /category | Get history for category ID
*DiscoverSnoop.HistoricalApi* | [**domainGet**](docs/HistoricalApi.md#domainGet) | **GET** /domain | Get history for domain name
*DiscoverSnoop.HistoricalApi* | [**domainsGet**](docs/HistoricalApi.md#domainsGet) | **GET** /domains | Get historical stats for domains
*DiscoverSnoop.HistoricalApi* | [**entitiesGet**](docs/HistoricalApi.md#entitiesGet) | **GET** /entities | Get historical stats for entities
*DiscoverSnoop.HistoricalApi* | [**entityGet**](docs/HistoricalApi.md#entityGet) | **GET** /entity | Get history for entity
*DiscoverSnoop.HistoricalApi* | [**pageGet**](docs/HistoricalApi.md#pageGet) | **GET** /page | Get page history for URL
*DiscoverSnoop.HistoricalApi* | [**pagesGet**](docs/HistoricalApi.md#pagesGet) | **GET** /pages | Get historical stats for pages
*DiscoverSnoop.InfoApi* | [**categoriesListGet**](docs/InfoApi.md#categoriesListGet) | **GET** /categories_list | Get list of categories used in the product
*DiscoverSnoop.InfoApi* | [**countriesListGet**](docs/InfoApi.md#countriesListGet) | **GET** /countries_list | Get list of countries available in the product
*DiscoverSnoop.KbApi* | [**kbArticlesGet**](docs/KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles
*DiscoverSnoop.LiveApi* | [**livecategoriesGet**](docs/LiveApi.md#livecategoriesGet) | **GET** /livecategories | Get livedata stats for categories
*DiscoverSnoop.LiveApi* | [**livedomainsGet**](docs/LiveApi.md#livedomainsGet) | **GET** /livedomains | Get livedata stats for domains
*DiscoverSnoop.LiveApi* | [**liveentitiesGet**](docs/LiveApi.md#liveentitiesGet) | **GET** /liveentities | Get livedata stats for entities
*DiscoverSnoop.LiveApi* | [**livepagesGet**](docs/LiveApi.md#livepagesGet) | **GET** /livepages | Get livedata stats for pages
*DiscoverSnoop.UserApi* | [**userCountriesChangeGet**](docs/UserApi.md#userCountriesChangeGet) | **GET** /user_countries_change | Change user&#x27;s activated countries
*DiscoverSnoop.UserApi* | [**userCustidChangeGet**](docs/UserApi.md#userCustidChangeGet) | **GET** /user_custid_change | Change user customer id. This function is system reserved
*DiscoverSnoop.UserApi* | [**userDeleteGet**](docs/UserApi.md#userDeleteGet) | **GET** /user_delete | Permanently delete the user
*DiscoverSnoop.UserApi* | [**userDetailsChangeGet**](docs/UserApi.md#userDetailsChangeGet) | **GET** /user_details_change | Change user details
*DiscoverSnoop.UserApi* | [**userLoginGet**](docs/UserApi.md#userLoginGet) | **GET** /user_login | Login user with his credentials
*DiscoverSnoop.UserApi* | [**userMessagesGet**](docs/UserApi.md#userMessagesGet) | **GET** /user_messages | Get messages for user
*DiscoverSnoop.UserApi* | [**userPasswordChangeGet**](docs/UserApi.md#userPasswordChangeGet) | **GET** /user_password_change | Change user password
*DiscoverSnoop.UserApi* | [**userPasswordResetGet**](docs/UserApi.md#userPasswordResetGet) | **GET** /user_password_reset | Reset user password
*DiscoverSnoop.UserApi* | [**userRefreshSubscriptionGet**](docs/UserApi.md#userRefreshSubscriptionGet) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*DiscoverSnoop.UserApi* | [**userRegisterGet**](docs/UserApi.md#userRegisterGet) | **GET** /user_register | Login user with his credentials

## Documentation for Models

 - [DiscoverSnoop.AlertCollection](docs/AlertCollection.md)
 - [DiscoverSnoop.Alerts](docs/Alerts.md)
 - [DiscoverSnoop.Categories](docs/Categories.md)
 - [DiscoverSnoop.CategoriesCollection](docs/CategoriesCollection.md)
 - [DiscoverSnoop.CategoriesList](docs/CategoriesList.md)
 - [DiscoverSnoop.CategoriesListCollection](docs/CategoriesListCollection.md)
 - [DiscoverSnoop.Category](docs/Category.md)
 - [DiscoverSnoop.CountriesList](docs/CountriesList.md)
 - [DiscoverSnoop.CountriesListCollection](docs/CountriesListCollection.md)
 - [DiscoverSnoop.DistributionCollection](docs/DistributionCollection.md)
 - [DiscoverSnoop.Domain](docs/Domain.md)
 - [DiscoverSnoop.Domains](docs/Domains.md)
 - [DiscoverSnoop.DomainsCollection](docs/DomainsCollection.md)
 - [DiscoverSnoop.Entities](docs/Entities.md)
 - [DiscoverSnoop.EntitiesCollection](docs/EntitiesCollection.md)
 - [DiscoverSnoop.Entity](docs/Entity.md)
 - [DiscoverSnoop.Favs](docs/Favs.md)
 - [DiscoverSnoop.FavsCollection](docs/FavsCollection.md)
 - [DiscoverSnoop.KB](docs/KB.md)
 - [DiscoverSnoop.KBCollection](docs/KBCollection.md)
 - [DiscoverSnoop.Message](docs/Message.md)
 - [DiscoverSnoop.MessageCollection](docs/MessageCollection.md)
 - [DiscoverSnoop.MetricsCollection](docs/MetricsCollection.md)
 - [DiscoverSnoop.Page](docs/Page.md)
 - [DiscoverSnoop.Pages](docs/Pages.md)
 - [DiscoverSnoop.PagesCollection](docs/PagesCollection.md)
 - [DiscoverSnoop.TransactionInfo](docs/TransactionInfo.md)
 - [DiscoverSnoop.UserCollection](docs/UserCollection.md)
 - [DiscoverSnoop.UserInfo](docs/UserInfo.md)

## Documentation for Authorization


### bearerAuth


