# DiscoverSnoop.InfoApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**categoriesListGet**](InfoApi.md#categoriesListGet) | **GET** /categories_list | Get list of categories used in the product
[**countriesListGet**](InfoApi.md#countriesListGet) | **GET** /countries_list | Get list of countries available in the product

<a name="categoriesListGet"></a>
# **categoriesListGet**
> [CategoriesList] categoriesListGet()

Get list of categories used in the product

### Example
```javascript
import {DiscoverSnoop} from 'discover_snoop';
let defaultClient = DiscoverSnoop.ApiClient.instance;


let apiInstance = new DiscoverSnoop.InfoApi();
apiInstance.categoriesListGet((error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[CategoriesList]**](CategoriesList.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="countriesListGet"></a>
# **countriesListGet**
> [CountriesList] countriesListGet()

Get list of countries available in the product

### Example
```javascript
import {DiscoverSnoop} from 'discover_snoop';
let defaultClient = DiscoverSnoop.ApiClient.instance;


let apiInstance = new DiscoverSnoop.InfoApi();
apiInstance.countriesListGet((error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[CountriesList]**](CountriesList.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

