# DiscoverSnoop.KbApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**kbArticlesGet**](KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles

<a name="kbArticlesGet"></a>
# **kbArticlesGet**
> [KB] kbArticlesGet(opts)

Get knowledge base articles

### Example
```javascript
import {DiscoverSnoop} from 'discover_snoop';
let defaultClient = DiscoverSnoop.ApiClient.instance;


let apiInstance = new DiscoverSnoop.KbApi();
let opts = { 
  'article': 56 // Number | ID of the requested article. 0 to get the full article list
};
apiInstance.kbArticlesGet(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **article** | **Number**| ID of the requested article. 0 to get the full article list | [optional] 

### Return type

[**[KB]**](KB.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

