/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import Alerts from '../model/Alerts';
import Domains from '../model/Domains';
import TransactionInfo from '../model/TransactionInfo';

/**
* Alerts service.
* @module api/AlertsApi
* @version 0.9.250210
*/
export default class AlertsApi {

    /**
    * Constructs a new AlertsApi. 
    * @alias module:api/AlertsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the alertsChangeGet operation.
     * @callback moduleapi/AlertsApi~alertsChangeGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Domains>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Edit or insert new alert
     * @param {String} id ID of the alert to edit ; if adding a new one leave blank
     * @param {String} alertname Name of the alert
     * @param {Boolean} activated Should the alert be activated or not
     * @param {Number} type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category
     * @param {Number} channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON
     * @param {String} recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint
     * @param {Object} opts Optional parameters
     * @param {String} opts.param1 Parameter 1 (meaning changes with alert type)
     * @param {String} opts.param2 Parameter 2 (meaning changes with alert type)
     * @param {String} opts.param3 Parameter 3 (meaning changes with alert type)
     * @param {String} opts.param4 Parameter 4 (meaning changes with alert type)
     * @param {String} opts.param5 Parameter 5 (meaning changes with alert type)
     * @param {String} opts.param6 Parameter 6 (meaning changes with alert type)
     * @param {module:api/AlertsApi~alertsChangeGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    alertsChangeGet(id, alertname, activated, type, channel, recipient, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling alertsChangeGet");
      }
      // verify the required parameter 'alertname' is set
      if (alertname === undefined || alertname === null) {
        throw new Error("Missing the required parameter 'alertname' when calling alertsChangeGet");
      }
      // verify the required parameter 'activated' is set
      if (activated === undefined || activated === null) {
        throw new Error("Missing the required parameter 'activated' when calling alertsChangeGet");
      }
      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling alertsChangeGet");
      }
      // verify the required parameter 'channel' is set
      if (channel === undefined || channel === null) {
        throw new Error("Missing the required parameter 'channel' when calling alertsChangeGet");
      }
      // verify the required parameter 'recipient' is set
      if (recipient === undefined || recipient === null) {
        throw new Error("Missing the required parameter 'recipient' when calling alertsChangeGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id,'alertname': alertname,'activated': activated,'type': type,'channel': channel,'recipient': recipient,'param1': opts['param1'],'param2': opts['param2'],'param3': opts['param3'],'param4': opts['param4'],'param5': opts['param5'],'param6': opts['param6']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Domains];

      return this.apiClient.callApi(
        '/alerts_change', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the alertsDeleteGet operation.
     * @callback moduleapi/AlertsApi~alertsDeleteGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Permanently delete the alert
     * @param {String} id alert id to delete
     * @param {module:api/AlertsApi~alertsDeleteGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    alertsDeleteGet(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling alertsDeleteGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/alerts_delete', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the alertsGet operation.
     * @callback moduleapi/AlertsApi~alertsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Alerts>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get alerts for user account
     * @param {module:api/AlertsApi~alertsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    alertsGet(callback) {
      
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Alerts];

      return this.apiClient.callApi(
        '/alerts', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}