/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import Favs from '../model/Favs';
import TransactionInfo from '../model/TransactionInfo';

/**
* Favs service.
* @module api/FavsApi
* @version 0.9.250210
*/
export default class FavsApi {

    /**
    * Constructs a new FavsApi. 
    * @alias module:api/FavsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the favsAddGet operation.
     * @callback moduleapi/FavsApi~favsAddGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new fav
     * @param {Object} opts Optional parameters
     * @param {String} opts.name Name of the fav.
     * @param {String} opts.action Action to be opened.
     * @param {String} opts.parameters Action&#x27;s parameters encoded in JSON.
     * @param {module:api/FavsApi~favsAddGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    favsAddGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'name': opts['name'],'action': opts['action'],'parameters': opts['parameters']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/favs_add', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the favsDeleteGet operation.
     * @callback moduleapi/FavsApi~favsDeleteGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Permanently delete the fav
     * @param {Object} opts Optional parameters
     * @param {String} opts.id ID of the fav to delete.
     * @param {module:api/FavsApi~favsDeleteGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    favsDeleteGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'id': opts['id']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/favs_delete', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the favsGet operation.
     * @callback moduleapi/FavsApi~favsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Favs>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get favorites
     * @param {Object} opts Optional parameters
     * @param {String} opts.id ID of the requested fav. ignore or set to 0 to get the full favs list
     * @param {module:api/FavsApi~favsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    favsGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'id': opts['id']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Favs];

      return this.apiClient.callApi(
        '/favs', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the favsUpdateGet operation.
     * @callback moduleapi/FavsApi~favsUpdateGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update the fav
     * @param {String} id ID of the fav that should be edited
     * @param {Object} opts Optional parameters
     * @param {String} opts.name Name of the fav.
     * @param {String} opts.action Action to be opened.
     * @param {String} opts.parameters Action&#x27;s parameters encoded in JSON.
     * @param {Number} opts.scheduled 0 if not scheduled, else x in hours
     * @param {String} opts.scheduledto email address of the recipient of this report
     * @param {module:api/FavsApi~favsUpdateGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    favsUpdateGet(id, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling favsUpdateGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id,'name': opts['name'],'action': opts['action'],'parameters': opts['parameters'],'scheduled': opts['scheduled'],'scheduledto': opts['scheduledto']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/favs_update', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}