/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import Categories from '../model/Categories';
import Category from '../model/Category';
import Domain from '../model/Domain';
import Domains from '../model/Domains';
import Entities from '../model/Entities';
import Entity from '../model/Entity';
import Page from '../model/Page';
import Pages from '../model/Pages';

/**
* Historical service.
* @module api/HistoricalApi
* @version 0.9.250210
*/
export default class HistoricalApi {

    /**
    * Constructs a new HistoricalApi. 
    * @alias module:api/HistoricalApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the categoriesGet operation.
     * @callback moduleapi/HistoricalApi~categoriesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Categories>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get historical stats for categories
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.keywordFilter Filter answers to cateogry names containing a particular keyword
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/HistoricalApi~categoriesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    categoriesGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling categoriesGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate'],'keyword_filter': opts['keywordFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Categories];

      return this.apiClient.callApi(
        '/categories', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the categoryGet operation.
     * @callback moduleapi/HistoricalApi~categoryGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Category>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get history for category ID
     * @param {String} id category id
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {module:api/HistoricalApi~categoryGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    categoryGet(id, country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling categoryGet");
      }
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling categoryGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id,'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Category];

      return this.apiClient.callApi(
        '/category', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the domainGet operation.
     * @callback moduleapi/HistoricalApi~domainGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Domain>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get history for domain name
     * @param {String} domain domain name (no subdomain allowed)
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {module:api/HistoricalApi~domainGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    domainGet(domain, country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'domain' is set
      if (domain === undefined || domain === null) {
        throw new Error("Missing the required parameter 'domain' when calling domainGet");
      }
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling domainGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'domain': domain,'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Domain];

      return this.apiClient.callApi(
        '/domain', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the domainsGet operation.
     * @callback moduleapi/HistoricalApi~domainsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Domains>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get historical stats for domains
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.urlFilter Filter answers to domains including a specified string
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/HistoricalApi~domainsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    domainsGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling domainsGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate'],'url_filter': opts['urlFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Domains];

      return this.apiClient.callApi(
        '/domains', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the entitiesGet operation.
     * @callback moduleapi/HistoricalApi~entitiesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Entities>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get historical stats for entities
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.keywordFilter Filter answers to entity names containing a particular keyword
     * @param {Number} opts.lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/HistoricalApi~entitiesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    entitiesGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling entitiesGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate'],'keyword_filter': opts['keywordFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Entities];

      return this.apiClient.callApi(
        '/entities', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the entityGet operation.
     * @callback moduleapi/HistoricalApi~entityGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Entity>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get history for entity
     * @param {String} name entity exact name URL encoded
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {module:api/HistoricalApi~entityGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    entityGet(name, country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'name' is set
      if (name === undefined || name === null) {
        throw new Error("Missing the required parameter 'name' when calling entityGet");
      }
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling entityGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'name': name,'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Entity];

      return this.apiClient.callApi(
        '/entity', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the pageGet operation.
     * @callback moduleapi/HistoricalApi~pageGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Page>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get page history for URL
     * @param {String} url Fully qualified page url. URL needs to be URL encoded
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param {module:api/HistoricalApi~pageGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    pageGet(url, country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'url' is set
      if (url === undefined || url === null) {
        throw new Error("Missing the required parameter 'url' when calling pageGet");
      }
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling pageGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'url': url,'country': country,'subcountry': opts['subcountry'],'from_date': opts['fromDate'],'to_date': opts['toDate']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Page];

      return this.apiClient.callApi(
        '/page', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the pagesGet operation.
     * @callback moduleapi/HistoricalApi~pagesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Pages>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get historical stats for pages
     * @param {Object} opts Optional parameters
     * @param {String} opts.fromDate Datas from YYYY-MM-DD (if not provided, last 30 days)
     * @param {String} opts.toDate Datas to YYYY-MM-DD (if not provided, last 30 days)
     * @param {String} opts.country ISO_3166 country code in 2 letters (if not provided  worldwide)
     * @param {String} opts.subcountry state code
     * @param {Number} opts.presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories
     * @param {String} opts.domainFilter Filter answers to pages of a designated domain name
     * @param {String} opts.keywordFilter Filter answers to pages titles containing a particular keyword
     * @param {String} opts.entityFilter Filter answers to pages with entities containing a particular keyword
     * @param {String} opts.urlFilter Filter answers to pages URL including a specified string
     * @param {Number} opts.categoryFilter Filter answers to a specific page category
     * @param {String} opts.languageFilter Filter answers to pages in specific user language
     * @param {Number} opts.lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/HistoricalApi~pagesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    pagesGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'from_date': opts['fromDate'],'to_date': opts['toDate'],'country': opts['country'],'subcountry': opts['subcountry'],'preset_filter': opts['presetFilter'],'domain_filter': opts['domainFilter'],'keyword_filter': opts['keywordFilter'],'entity_filter': opts['entityFilter'],'url_filter': opts['urlFilter'],'category_filter': opts['categoryFilter'],'language_filter': opts['languageFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Pages];

      return this.apiClient.callApi(
        '/pages', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}