/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import KB from '../model/KB';

/**
* Kb service.
* @module api/KbApi
* @version 0.9.250210
*/
export default class KbApi {

    /**
    * Constructs a new KbApi. 
    * @alias module:api/KbApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the kbArticlesGet operation.
     * @callback moduleapi/KbApi~kbArticlesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/KB>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get knowledge base articles
     * @param {Object} opts Optional parameters
     * @param {Number} opts.article ID of the requested article. 0 to get the full article list
     * @param {module:api/KbApi~kbArticlesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    kbArticlesGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'article': opts['article']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [KB];

      return this.apiClient.callApi(
        '/kb_articles', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}