/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import Categories from '../model/Categories';
import Domains from '../model/Domains';
import Entities from '../model/Entities';
import Pages from '../model/Pages';

/**
* Live service.
* @module api/LiveApi
* @version 0.9.250210
*/
export default class LiveApi {

    /**
    * Constructs a new LiveApi. 
    * @alias module:api/LiveApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the livecategoriesGet operation.
     * @callback moduleapi/LiveApi~livecategoriesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Categories>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get livedata stats for categories
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {Number} opts.hours Get results for last x hours
     * @param {String} opts.keywordFilter Filter answers to category names containing a particular keyword
     * @param {String} opts.languageFilter Filter answers to pages in specific user language
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/LiveApi~livecategoriesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    livecategoriesGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling livecategoriesGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'hours': opts['hours'],'keyword_filter': opts['keywordFilter'],'language_filter': opts['languageFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Categories];

      return this.apiClient.callApi(
        '/livecategories', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the livedomainsGet operation.
     * @callback moduleapi/LiveApi~livedomainsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Domains>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get livedata stats for domains
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {String} opts.urlFilter Filter answers to domains including a specified string
     * @param {Number} opts.hours Get results for last x hours
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {String} opts.languageFilter Filter answers to pages in specific user language
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/LiveApi~livedomainsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    livedomainsGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling livedomainsGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'url_filter': opts['urlFilter'],'hours': opts['hours'],'lines': opts['lines'],'language_filter': opts['languageFilter'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Domains];

      return this.apiClient.callApi(
        '/livedomains', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the liveentitiesGet operation.
     * @callback moduleapi/LiveApi~liveentitiesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Entities>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get livedata stats for entities
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {Number} opts.hours Get results for last x hours
     * @param {String} opts.keywordFilter Filter answers to entity names containing a particular keyword
     * @param {Number} opts.categoryFilter Filter answers to pages of a designated category id
     * @param {String} opts.languageFilter Filter answers to pages in specific user language
     * @param {String} opts.domainFilter Filter answers to pages of a designated domain name
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/LiveApi~liveentitiesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    liveentitiesGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling liveentitiesGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'hours': opts['hours'],'keyword_filter': opts['keywordFilter'],'category_filter': opts['categoryFilter'],'language_filter': opts['languageFilter'],'domain_filter': opts['domainFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Entities];

      return this.apiClient.callApi(
        '/liveentities', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the livepagesGet operation.
     * @callback moduleapi/LiveApi~livepagesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Pages>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get livedata stats for pages
     * @param {String} country ISO_3166 country code in 2 letters
     * @param {Object} opts Optional parameters
     * @param {String} opts.subcountry state code
     * @param {Number} opts.hours Get results for last x hours
     * @param {Number} opts.presetFilter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories
     * @param {Number} opts.onlyNew Get only pages first seen in the reporting period if set on 1 (default to <.>)
     * @param {String} opts.domainFilter Filter answers to pages of a designated domain name
     * @param {String} opts.keywordFilter Filter answers to pages titles containing a particular keyword
     * @param {String} opts.entityFilter Filter answers to pages with entities containing a particular keyword
     * @param {String} opts.urlFilter Filter answers to pages URL including a specified string
     * @param {Number} opts.categoryFilter Filter answers to pages of a designated category id
     * @param {String} opts.languageFilter Filter answers to pages in specific user language
     * @param {Number} opts.lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (default to <.>)
     * @param {Number} opts.offset Get paginated results from X offset (default to <.>)
     * @param {module:api/LiveApi~livepagesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    livepagesGet(country, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'country' is set
      if (country === undefined || country === null) {
        throw new Error("Missing the required parameter 'country' when calling livepagesGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'country': country,'subcountry': opts['subcountry'],'hours': opts['hours'],'preset_filter': opts['presetFilter'],'only_new': opts['onlyNew'],'domain_filter': opts['domainFilter'],'keyword_filter': opts['keywordFilter'],'entity_filter': opts['entityFilter'],'url_filter': opts['urlFilter'],'category_filter': opts['categoryFilter'],'language_filter': opts['languageFilter'],'lines': opts['lines'],'offset': opts['offset']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Pages];

      return this.apiClient.callApi(
        '/livepages', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}