/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.67
 *
 * Do not edit the class manually.
 *
 */
import ApiClient from "../ApiClient";
import Message from '../model/Message';
import TransactionInfo from '../model/TransactionInfo';
import UserInfo from '../model/UserInfo';

/**
* User service.
* @module api/UserApi
* @version 0.9.250210
*/
export default class UserApi {

    /**
    * Constructs a new UserApi. 
    * @alias module:api/UserApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the userCountriesChangeGet operation.
     * @callback moduleapi/UserApi~userCountriesChangeGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change user&#x27;s activated countries
     * @param {String} countries json encoded string representing countries to activate
     * @param {String} categories json encoded string representing categories ID to activate
     * @param {module:api/UserApi~userCountriesChangeGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userCountriesChangeGet(countries, categories, callback) {
      
      let postBody = null;
      // verify the required parameter 'countries' is set
      if (countries === undefined || countries === null) {
        throw new Error("Missing the required parameter 'countries' when calling userCountriesChangeGet");
      }
      // verify the required parameter 'categories' is set
      if (categories === undefined || categories === null) {
        throw new Error("Missing the required parameter 'categories' when calling userCountriesChangeGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'countries': countries,'categories': categories
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_countries_change', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userCustidChangeGet operation.
     * @callback moduleapi/UserApi~userCustidChangeGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change user customer id. This function is system reserved
     * @param {String} custid new customer id for user
     * @param {module:api/UserApi~userCustidChangeGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userCustidChangeGet(custid, callback) {
      
      let postBody = null;
      // verify the required parameter 'custid' is set
      if (custid === undefined || custid === null) {
        throw new Error("Missing the required parameter 'custid' when calling userCustidChangeGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'custid': custid
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_custid_change', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userDeleteGet operation.
     * @callback moduleapi/UserApi~userDeleteGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Permanently delete the user
     * @param {module:api/UserApi~userDeleteGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userDeleteGet(callback) {
      
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_delete', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userDetailsChangeGet operation.
     * @callback moduleapi/UserApi~userDetailsChangeGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change user details
     * @param {String} email new email address for user
     * @param {String} fname new firstname for user
     * @param {String} lname new lastname for user
     * @param {Object} opts Optional parameters
     * @param {String} opts.translation update the translation settings for user original (will show original titles) | english (will show titles translated in english)
     * @param {module:api/UserApi~userDetailsChangeGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userDetailsChangeGet(email, fname, lname, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling userDetailsChangeGet");
      }
      // verify the required parameter 'fname' is set
      if (fname === undefined || fname === null) {
        throw new Error("Missing the required parameter 'fname' when calling userDetailsChangeGet");
      }
      // verify the required parameter 'lname' is set
      if (lname === undefined || lname === null) {
        throw new Error("Missing the required parameter 'lname' when calling userDetailsChangeGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'email': email,'fname': fname,'lname': lname,'translation': opts['translation']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_details_change', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userLoginGet operation.
     * @callback moduleapi/UserApi~userLoginGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/UserInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login user with his credentials
     * @param {String} email email address for user
     * @param {String} password password for user
     * @param {Object} opts Optional parameters
     * @param {Number} opts.pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot;
     * @param {module:api/UserApi~userLoginGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userLoginGet(email, password, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling userLoginGet");
      }
      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling userLoginGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'email': email,'password': password,'pin': opts['pin']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [UserInfo];

      return this.apiClient.callApi(
        '/user_login', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userMessagesGet operation.
     * @callback moduleapi/UserApi~userMessagesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Message>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get messages for user
     * @param {Object} opts Optional parameters
     * @param {Number} opts.message ID of the requested message. 0 to get the full message list
     * @param {module:api/UserApi~userMessagesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userMessagesGet(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'message': opts['message']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Message];

      return this.apiClient.callApi(
        '/user_messages', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userPasswordChangeGet operation.
     * @callback moduleapi/UserApi~userPasswordChangeGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change user password
     * @param {String} email email address for user
     * @param {String} password current password for user
     * @param {String} newpassword new password to set up for user
     * @param {module:api/UserApi~userPasswordChangeGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userPasswordChangeGet(email, password, newpassword, callback) {
      
      let postBody = null;
      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling userPasswordChangeGet");
      }
      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling userPasswordChangeGet");
      }
      // verify the required parameter 'newpassword' is set
      if (newpassword === undefined || newpassword === null) {
        throw new Error("Missing the required parameter 'newpassword' when calling userPasswordChangeGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'email': email,'password': password,'newpassword': newpassword
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_password_change', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userPasswordResetGet operation.
     * @callback moduleapi/UserApi~userPasswordResetGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TransactionInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Reset user password
     * @param {String} email email address for user
     * @param {module:api/UserApi~userPasswordResetGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userPasswordResetGet(email, callback) {
      
      let postBody = null;
      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling userPasswordResetGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'email': email
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [TransactionInfo];

      return this.apiClient.callApi(
        '/user_password_reset', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userRefreshSubscriptionGet operation.
     * @callback moduleapi/UserApi~userRefreshSubscriptionGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/UserInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Refresh user rights with his Customer ID. This function is system reserved
     * @param {String} custid Customer ID for the user
     * @param {module:api/UserApi~userRefreshSubscriptionGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userRefreshSubscriptionGet(custid, callback) {
      
      let postBody = null;
      // verify the required parameter 'custid' is set
      if (custid === undefined || custid === null) {
        throw new Error("Missing the required parameter 'custid' when calling userRefreshSubscriptionGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'custid': custid
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [UserInfo];

      return this.apiClient.callApi(
        '/user_refresh_subscription', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the userRegisterGet operation.
     * @callback moduleapi/UserApi~userRegisterGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/UserInfo>{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login user with his credentials
     * @param {String} email email address for user
     * @param {String} password password for user
     * @param {String} fname new firstname for user
     * @param {String} lname new lastname for user
     * @param {Object} opts Optional parameters
     * @param {String} opts.referrer referrer for this user. should be urlencoded
     * @param {module:api/UserApi~userRegisterGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    userRegisterGet(email, password, fname, lname, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'email' is set
      if (email === undefined || email === null) {
        throw new Error("Missing the required parameter 'email' when calling userRegisterGet");
      }
      // verify the required parameter 'password' is set
      if (password === undefined || password === null) {
        throw new Error("Missing the required parameter 'password' when calling userRegisterGet");
      }
      // verify the required parameter 'fname' is set
      if (fname === undefined || fname === null) {
        throw new Error("Missing the required parameter 'fname' when calling userRegisterGet");
      }
      // verify the required parameter 'lname' is set
      if (lname === undefined || lname === null) {
        throw new Error("Missing the required parameter 'lname' when calling userRegisterGet");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'email': email,'password': password,'fname': fname,'lname': lname,'referrer': opts['referrer']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [UserInfo];

      return this.apiClient.callApi(
        '/user_register', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}